diff --git a/roms/ipxe/src/core/settings.c b/roms/ipxe/src/core/settings.c
index 0a8c5f68e21b77ebd044a950fa5c..656ae19fe642b55914f9a80888d9 100644
--- a/roms/ipxe/src/core/settings.c
+++ b/roms/ipxe/src/core/settings.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -31,6 +32,7 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <ipxe/dhcp.h>
 #include <ipxe/uuid.h>
 #include <ipxe/uri.h>
+#include <ipxe/init.h>
 #include <ipxe/settings.h>
 
 /** @file
@@ -178,6 +180,11 @@ int generic_settings_fetch ( struct settings *settings,
 	if ( len > generic->data_len )
 		len = generic->data_len;
 	memcpy ( data, generic_setting_data ( generic ), len );
+
+	/* Set setting type, if not yet specified */
+	if ( ! setting->type )
+		setting->type = generic->setting.type;
+
 	return generic->data_len;
 }
 
@@ -258,8 +265,8 @@ static void autovivified_settings_free ( struct refcnt *refcnt ) {
  * @v name		Name within this parent
  * @ret settings	Settings block, or NULL
  */
-static struct settings * find_child_settings ( struct settings *parent,
-					       const char *name ) {
+struct settings * find_child_settings ( struct settings *parent,
+					const char *name ) {
 	struct settings *settings;
 
 	/* Treat empty name as meaning "this block" */
@@ -612,8 +619,12 @@ static int fetch_setting_and_origin ( struct settings *settings,
 	if ( setting_applies ( settings, setting ) &&
 	     ( ( ret = settings->op->fetch ( settings, setting,
 					     data, len ) ) >= 0 ) ) {
+		/* Record origin, if applicable */
 		if ( origin )
 			*origin = settings;
+		/* Default to string setting type, if not yet specified */
+		if ( ! setting->type )
+			setting->type = &setting_type_string;
 		return ret;
 	}
 
@@ -676,6 +687,46 @@ int fetch_setting_len ( struct settings *settings, struct setting *setting ) {
 	return fetch_setting ( settings, setting, NULL, 0 );
 }
 
+/**
+ * Fetch copy of setting
+ *
+ * @v settings		Settings block, or NULL to search all blocks
+ * @v setting		Setting to fetch
+ * @v data		Buffer to allocate and fill with setting data
+ * @ret len		Length of setting, or negative error
+ *
+ * The caller is responsible for eventually freeing the allocated
+ * buffer.
+ *
+ * To allow the caller to distinguish between a non-existent setting
+ * and an error in allocating memory for the copy, this function will
+ * return success (and a NULL buffer pointer) for a non-existent
+ * setting.
+ */
+int fetch_setting_copy ( struct settings *settings, struct setting *setting,
+			 void **data ) {
+	int len;
+	int check_len = 0;
+
+	/* Avoid returning uninitialised data on error */
+	*data = NULL;
+
+	/* Fetch setting length, and return success if non-existent */
+	len = fetch_setting_len ( settings, setting );
+	if ( len < 0 )
+		return 0;
+
+	/* Allocate buffer */
+	*data = malloc ( len );
+	if ( ! *data )
+		return -ENOMEM;
+
+	/* Fetch setting */
+	check_len = fetch_setting ( settings, setting, *data, len );
+	assert ( check_len == len );
+	return len;
+}
+
 /**
  * Fetch value of string setting
  *
@@ -776,6 +827,41 @@ int fetch_ipv4_setting ( struct settings *settings, struct setting *setting,
 	return fetch_ipv4_array_setting ( settings, setting, inp, 1 );
 }
 
+/**
+ * Extract numeric value of setting
+ *
+ * @v raw		Raw setting data
+ * @v len		Length of raw setting data
+ * @ret signed_value	Value, when interpreted as a signed integer
+ * @ret unsigned_value	Value, when interpreted as an unsigned integer
+ * @ret len		Length of setting, or negative error
+ */
+static int numeric_setting_value ( const void *raw, size_t len,
+				   signed long *signed_value,
+				   unsigned long *unsigned_value ) {
+	const uint8_t *unsigned_bytes = raw;
+	const int8_t *signed_bytes = raw;
+	int is_negative;
+	unsigned int i;
+	uint8_t byte;
+
+	/* Range check */
+	if ( len > sizeof ( long ) )
+		return -ERANGE;
+
+	/* Convert to host-ordered longs */
+	is_negative = ( len && ( signed_bytes[0] < 0 ) );
+	*signed_value = ( is_negative ? -1L : 0 );
+	*unsigned_value = 0;
+	for ( i = 0 ; i < len ; i++ ) {
+		byte = unsigned_bytes[i];
+		*signed_value = ( ( *signed_value << 8 ) | byte );
+		*unsigned_value = ( ( *unsigned_value << 8 ) | byte );
+	}
+
+	return len;
+}
+
 /**
  * Fetch value of signed integer setting
  *
@@ -786,30 +872,20 @@ int fetch_ipv4_setting ( struct settings *settings, struct setting *setting,
  */
 int fetch_int_setting ( struct settings *settings, struct setting *setting,
 			long *value ) {
-	union {
-		uint8_t u8[ sizeof ( long ) ];
-		int8_t s8[ sizeof ( long ) ];
-	} buf;
+	unsigned long dummy;
+	long tmp;
 	int len;
-	int i;
 
 	/* Avoid returning uninitialised data on error */
 	*value = 0;
 
 	/* Fetch raw (network-ordered, variable-length) setting */
-	len = fetch_setting ( settings, setting, &buf, sizeof ( buf ) );
+	len = fetch_setting ( settings, setting, &tmp, sizeof ( tmp ) );
 	if ( len < 0 )
 		return len;
-	if ( len > ( int ) sizeof ( buf ) )
-		return -ERANGE;
-
-	/* Convert to host-ordered signed long */
-	*value = ( ( buf.s8[0] >= 0 ) ? 0 : -1L );
-	for ( i = 0 ; i < len ; i++ ) {
-		*value = ( ( *value << 8 ) | buf.u8[i] );
-	}
 
-	return len;
+	/* Extract numeric value */
+	return numeric_setting_value ( &tmp, len, value, &dummy );
 }
 
 /**
@@ -822,22 +898,20 @@ int fetch_int_setting ( struct settings *settings, struct setting *setting,
  */
 int fetch_uint_setting ( struct settings *settings, struct setting *setting,
 			 unsigned long *value ) {
-	long svalue;
+	signed long dummy;
+	long tmp;
 	int len;
 
 	/* Avoid returning uninitialised data on error */
 	*value = 0;
 
-	/* Fetch as a signed long */
-	len = fetch_int_setting ( settings, setting, &svalue );
+	/* Fetch raw (network-ordered, variable-length) setting */
+	len = fetch_setting ( settings, setting, &tmp, sizeof ( tmp ) );
 	if ( len < 0 )
 		return len;
 
-	/* Mask off sign-extended bits */
-	assert ( len <= ( int ) sizeof ( long ) );
-	*value = ( svalue & ( -1UL >> ( 8 * ( sizeof ( long ) - len ) ) ) );
-
-	return len;
+	/* Extract numeric value */
+	return numeric_setting_value ( &tmp, len, &dummy, value );
 }
 
 /**
@@ -929,27 +1003,83 @@ int setting_cmp ( struct setting *a, struct setting *b ) {
  */
 
 /**
- * Store value of typed setting
+ * Fetch and format value of setting
+ *
+ * @v settings		Settings block, or NULL to search all blocks
+ * @v setting		Setting to fetch
+ * @v type		Settings type
+ * @v buf		Buffer to contain formatted value
+ * @v len		Length of buffer
+ * @ret len		Length of formatted value, or negative error
+ */
+int fetchf_setting ( struct settings *settings, struct setting *setting,
+		     char *buf, size_t len ) {
+	int raw_len;
+	int check_len;
+	int rc;
+
+	/* Fetch raw value */
+	raw_len = fetch_setting_len ( settings, setting );
+	if ( raw_len < 0 ) {
+		rc = raw_len;
+		return rc;
+	} else {
+		uint8_t raw[raw_len];
+
+		/* Fetch raw value */
+		check_len = fetch_setting ( settings, setting, raw,
+					    sizeof ( raw ) );
+		if ( check_len < 0 )
+			return check_len;
+		assert ( check_len == raw_len );
+
+		/* Format value */
+		return setting->type->format ( raw, sizeof ( raw ), buf, len );
+	}
+}
+
+/**
+ * Store formatted value of setting
  *
  * @v settings		Settings block
  * @v setting		Setting to store
- * @v type		Settings type
  * @v value		Formatted setting data, or NULL
  * @ret rc		Return status code
  */
 int storef_setting ( struct settings *settings, struct setting *setting,
 		     const char *value ) {
+	int raw_len;
+	int check_len;
+	int rc;
 
-	/* NULL value implies deletion.  Avoid imposing the burden of
-	 * checking for NULL values on each typed setting's storef()
-	 * method.
-	 */
-	if ( ! value )
+	/* NULL value or empty string implies deletion */
+	if ( ( ! value ) || ( ! value[0] ) )
 		return delete_setting ( settings, setting );
-		
-	return setting->type->storef ( settings, setting, value );
+
+	/* Parse formatted value */
+	raw_len = setting->type->parse ( value, NULL, 0 );
+	if ( raw_len < 0 ) {
+		rc = raw_len;
+		return rc;
+	} else {
+		uint8_t raw[raw_len];
+
+		/* Parse formatted value */
+		check_len = setting->type->parse ( value, raw, sizeof ( raw ) );
+		assert ( check_len == raw_len );
+
+		/* Store raw value */
+		return store_setting ( settings, setting, raw, sizeof ( raw ) );
+	}
 }
 
+/******************************************************************************
+ *
+ * Named settings
+ *
+ ******************************************************************************
+ */
+
 /**
  * Find named setting
  *
@@ -1011,6 +1141,7 @@ static struct setting_type * find_setting_type ( const char *name ) {
  * @v get_child		Function to find or create child settings block
  * @v settings		Settings block to fill in
  * @v setting		Setting to fill in
+ * @v default_type	Default type to use, if none specified
  * @v tmp_name		Buffer for copy of setting name
  * @ret rc		Return status code
  *
@@ -1026,6 +1157,7 @@ parse_setting_name ( const char *name,
 		     struct settings * ( * get_child ) ( struct settings *,
 							 const char * ),
 		     struct settings **settings, struct setting *setting,
+		     struct setting_type *default_type,
 		     char *tmp_name ) {
 	char *settings_name;
 	char *setting_name;
@@ -1036,7 +1168,7 @@ parse_setting_name ( const char *name,
 	*settings = &settings_root;
 	memset ( setting, 0, sizeof ( *setting ) );
 	setting->name = "";
-	setting->type = &setting_type_string;
+	setting->type = default_type;
 
 	/* Split name into "[settings_name/]setting_name[:type_name]" */
 	strcpy ( tmp_name, name );
@@ -1105,14 +1237,45 @@ int setting_name ( struct settings *settings, struct setting *setting,
 			  setting->name, setting->type->name );
 }
 
+/**
+ * Store value of named setting
+ *
+ * @v name		Name of setting
+ * @v default_type	Default type to use, if none specified
+ * @v data		Setting data, or NULL to clear setting
+ * @v len		Length of setting data
+ * @ret rc		Return status code
+ */
+int store_named_setting ( const char *name, struct setting_type *default_type,
+			  const void *data, size_t len ) {
+	struct settings *settings;
+	struct setting setting;
+	char tmp_name[ strlen ( name ) + 1 ];
+	int rc;
+
+	/* Parse setting name */
+	if ( ( rc = parse_setting_name ( name, autovivify_child_settings,
+					 &settings, &setting, default_type,
+					 tmp_name ) ) != 0 )
+		return rc;
+
+	/* Store setting */
+	if ( ( rc = store_setting ( settings, &setting, data, len ) ) != 0 )
+		return rc;
+
+	return 0;
+}
+
 /**
  * Parse and store value of named setting
  *
  * @v name		Name of setting
+ * @v default_type	Default type to use, if none specified
  * @v value		Formatted setting data, or NULL
  * @ret rc		Return status code
  */
-int storef_named_setting ( const char *name, const char *value ) {
+int storef_named_setting ( const char *name, struct setting_type *default_type,
+			   const char *value ) {
 	struct settings *settings;
 	struct setting setting;
 	char tmp_name[ strlen ( name ) + 1 ];
@@ -1120,7 +1283,8 @@ int storef_named_setting ( const char *name, const char *value ) {
 
 	/* Parse setting name */
 	if ( ( rc = parse_setting_name ( name, autovivify_child_settings,
-					 &settings, &setting, tmp_name )) != 0)
+					 &settings, &setting, default_type,
+					 tmp_name ) ) != 0 )
 		return rc;
 
 	/* Store setting */
@@ -1151,8 +1315,8 @@ int fetchf_named_setting ( const char *name,
 	int rc;
 
 	/* Parse setting name */
-	if ( ( rc = parse_setting_name ( name, find_child_settings,
-					 &settings, &setting, tmp_name )) != 0)
+	if ( ( rc = parse_setting_name ( name, find_child_settings, &settings,
+					 &setting, NULL, tmp_name ) ) != 0 )
 		return rc;
 
 	/* Fetch setting */
@@ -1168,6 +1332,45 @@ int fetchf_named_setting ( const char *name,
 	return len;
 }
 
+/**
+ * Fetch and format copy of value of named setting
+ *
+ * @v name		Name of setting
+ * @v data		Buffer to allocate and fill with formatted value
+ * @ret len		Length of formatted value, or negative error
+ *
+ * The caller is responsible for eventually freeing the allocated
+ * buffer.
+ *
+ * To allow the caller to distinguish between a non-existent setting
+ * and an error in allocating memory for the copy, this function will
+ * return success (and a NULL buffer pointer) for a non-existent
+ * setting.
+ */
+int fetchf_named_setting_copy ( const char *name, char **data ) {
+	int len;
+	int check_len;
+
+	/* Avoid returning uninitialised data on error */
+	*data = NULL;
+
+	/* Fetch formatted value length, and return success if non-existent */
+	len = fetchf_named_setting ( name, NULL, 0, NULL, 0 );
+	if ( len < 0 )
+		return 0;
+
+	/* Allocate buffer */
+	*data = malloc ( len + 1 /* NUL */ );
+	if ( ! *data )
+		return -ENOMEM;
+
+	/* Fetch formatted value */
+	check_len = fetchf_named_setting ( name, NULL, 0, *data,
+					   ( len + 1 /* NUL */ ) );
+	assert ( check_len == len );
+	return len;
+}
+
 /******************************************************************************
  *
  * Setting types
@@ -1176,302 +1379,334 @@ int fetchf_named_setting ( const char *name,
  */
 
 /**
- * Parse and store value of string setting
+ * Parse string setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
- * @ret rc		Return status code
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_string ( struct settings *settings, struct setting *setting,
-			   const char *value ) {
-	return store_setting ( settings, setting, value, strlen ( value ) );
+static int parse_string_setting ( const char *value, void *buf, size_t len ) {
+	size_t raw_len = strlen ( value ); /* Exclude terminating NUL */
+
+	/* Copy string to buffer */
+	if ( len > raw_len )
+		len = raw_len;
+	memcpy ( buf, value, len );
+
+	return raw_len;
 }
 
 /**
- * Fetch and format value of string setting
+ * Format string setting value
  *
- * @v settings		Settings block, or NULL to search all blocks
- * @v setting		Setting to fetch
+ * @v raw		Raw setting value
+ * @v raw_len		Length of raw setting value
  * @v buf		Buffer to contain formatted value
  * @v len		Length of buffer
  * @ret len		Length of formatted value, or negative error
  */
-static int fetchf_string ( struct settings *settings, struct setting *setting,
-			   char *buf, size_t len ) {
-	return fetch_string_setting ( settings, setting, buf, len );
+static int format_string_setting ( const void *raw, size_t raw_len, char *buf,
+				   size_t len ) {
+
+	/* Copy string to buffer, and terminate */
+	memset ( buf, 0, len );
+	if ( len > raw_len )
+		len = raw_len;
+	memcpy ( buf, raw, len );
+
+	return raw_len;
 }
 
 /** A string setting type */
 struct setting_type setting_type_string __setting_type = {
 	.name = "string",
-	.storef = storef_string,
-	.fetchf = fetchf_string,
+	.parse = parse_string_setting,
+	.format = format_string_setting,
 };
 
 /**
- * Parse and store value of URI-encoded string setting
+ * Parse URI-encoded string setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
- * @ret rc		Return status code
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_uristring ( struct settings *settings,
-			      struct setting *setting,
-			      const char *value ) {
-	char buf[ strlen ( value ) + 1 ]; /* Decoding never expands string */
-	size_t len;
+static int parse_uristring_setting ( const char *value, void *buf,
+				     size_t len ) {
+	char tmp[ len + 1 /* NUL */ ];
+	size_t raw_len;
+
+	/* Decode to temporary buffer (including NUL) */
+	raw_len = uri_decode ( value, tmp, sizeof ( tmp ) );
 
-	len = uri_decode ( value, buf, sizeof ( buf ) );
-	return store_setting ( settings, setting, buf, len );
+	/* Copy to output buffer (excluding NUL) */
+	if ( len > raw_len )
+		len = raw_len;
+	memcpy ( buf, tmp, len );
+
+	return raw_len;
 }
 
 /**
- * Fetch and format value of URI-encoded string setting
+ * Format URI-encoded string setting value
  *
- * @v settings		Settings block, or NULL to search all blocks
- * @v setting		Setting to fetch
+ * @v raw		Raw setting value
+ * @v raw_len		Length of raw setting value
  * @v buf		Buffer to contain formatted value
  * @v len		Length of buffer
  * @ret len		Length of formatted value, or negative error
  */
-static int fetchf_uristring ( struct settings *settings,
-			      struct setting *setting,
-			      char *buf, size_t len ) {
-	ssize_t raw_len;
+static int format_uristring_setting ( const void *raw, size_t raw_len,
+				      char *buf, size_t len ) {
+	char tmp[ raw_len + 1 /* NUL */ ];
 
-	/* We need to always retrieve the full raw string to know the
-	 * length of the encoded string.
-	 */
-	raw_len = fetch_setting ( settings, setting, NULL, 0 );
-	if ( raw_len < 0 )
-		return raw_len;
-
-	{
-		char raw_buf[ raw_len + 1 ];
-       
-		fetch_string_setting ( settings, setting, raw_buf,
-				       sizeof ( raw_buf ) );
-		return uri_encode ( raw_buf, buf, len, URI_FRAGMENT );
-	}
+	/* Copy to temporary buffer and terminate */
+	memcpy ( tmp, raw, raw_len );
+	tmp[raw_len] = '\0';
+
+	/* Encode directly into output buffer */
+	return uri_encode ( tmp, buf, len, URI_FRAGMENT );
 }
 
 /** A URI-encoded string setting type */
 struct setting_type setting_type_uristring __setting_type = {
 	.name = "uristring",
-	.storef = storef_uristring,
-	.fetchf = fetchf_uristring,
+	.parse = parse_uristring_setting,
+	.format = format_uristring_setting,
 };
 
 /**
- * Parse and store value of IPv4 address setting
+ * Parse IPv4 address setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
- * @ret rc		Return status code
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_ipv4 ( struct settings *settings, struct setting *setting,
-			 const char *value ) {
+static int parse_ipv4_setting ( const char *value, void *buf, size_t len ) {
 	struct in_addr ipv4;
 
+	/* Parse IPv4 address */
 	if ( inet_aton ( value, &ipv4 ) == 0 )
 		return -EINVAL;
-	return store_setting ( settings, setting, &ipv4, sizeof ( ipv4 ) );
+
+	/* Copy to buffer */
+	if ( len > sizeof ( ipv4 ) )
+		len = sizeof ( ipv4 );
+	memcpy ( buf, &ipv4, len );
+
+	return ( sizeof ( ipv4 ) );
 }
 
 /**
- * Fetch and format value of IPv4 address setting
+ * Format IPv4 address setting value
  *
- * @v settings		Settings block, or NULL to search all blocks
- * @v setting		Setting to fetch
+ * @v raw		Raw setting value
+ * @v raw_len		Length of raw setting value
  * @v buf		Buffer to contain formatted value
  * @v len		Length of buffer
  * @ret len		Length of formatted value, or negative error
  */
-static int fetchf_ipv4 ( struct settings *settings, struct setting *setting,
-			 char *buf, size_t len ) {
-	struct in_addr ipv4;
-	int raw_len;
+static int format_ipv4_setting ( const void *raw, size_t raw_len, char *buf,
+				 size_t len ) {
+	const struct in_addr *ipv4 = raw;
 
-	if ( ( raw_len = fetch_ipv4_setting ( settings, setting, &ipv4 ) ) < 0)
-		return raw_len;
-	return snprintf ( buf, len, "%s", inet_ntoa ( ipv4 ) );
+	if ( raw_len < sizeof ( *ipv4 ) )
+		return -EINVAL;
+	return snprintf ( buf, len, "%s", inet_ntoa ( *ipv4 ) );
 }
 
 /** An IPv4 address setting type */
 struct setting_type setting_type_ipv4 __setting_type = {
 	.name = "ipv4",
-	.storef = storef_ipv4,
-	.fetchf = fetchf_ipv4,
+	.parse = parse_ipv4_setting,
+	.format = format_ipv4_setting,
 };
 
 /**
- * Parse and store value of integer setting
+ * Parse integer setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
  * @v size		Integer size, in bytes
- * @ret rc		Return status code
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_int ( struct settings *settings, struct setting *setting,
-			const char *value, unsigned int size ) {
+static int parse_int_setting ( const char *value, void *buf, size_t len,
+			       unsigned int size ) {
 	union {
 		uint32_t num;
 		uint8_t bytes[4];
 	} u;
 	char *endp;
 
+	/* Parse value */
 	u.num = htonl ( strtoul ( value, &endp, 0 ) );
 	if ( *endp )
 		return -EINVAL;
-	return store_setting ( settings, setting, 
-			       &u.bytes[ sizeof ( u ) - size ], size );
+
+	/* Copy to buffer */
+	if ( len > size )
+		len = size;
+	memcpy ( buf, &u.bytes[ sizeof ( u ) - size ], len );
+
+	return size;
 }
 
 /**
- * Parse and store value of 8-bit integer setting
+ * Parse 8-bit integer setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
  * @v size		Integer size, in bytes
- * @ret rc		Return status code
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_int8 ( struct settings *settings, struct setting *setting,
-			 const char *value ) {
-	return storef_int ( settings, setting, value, 1 );
+static int parse_int8_setting ( const char *value, void *buf, size_t len ) {
+	return parse_int_setting ( value, buf, len, sizeof ( uint8_t ) );
 }
 
 /**
- * Parse and store value of 16-bit integer setting
+ * Parse 16-bit integer setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
  * @v size		Integer size, in bytes
- * @ret rc		Return status code
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_int16 ( struct settings *settings, struct setting *setting,
-			  const char *value ) {
-	return storef_int ( settings, setting, value, 2 );
+static int parse_int16_setting ( const char *value, void *buf, size_t len ) {
+	return parse_int_setting ( value, buf, len, sizeof ( uint16_t ) );
 }
 
 /**
- * Parse and store value of 32-bit integer setting
+ * Parse 32-bit integer setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
  * @v size		Integer size, in bytes
- * @ret rc		Return status code
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_int32 ( struct settings *settings, struct setting *setting,
-			  const char *value ) {
-	return storef_int ( settings, setting, value, 4 );
+static int parse_int32_setting ( const char *value, void *buf, size_t len ) {
+	return parse_int_setting ( value, buf, len, sizeof ( uint32_t ) );
 }
 
 /**
- * Fetch and format value of signed integer setting
+ * Format signed integer setting value
  *
- * @v settings		Settings block, or NULL to search all blocks
- * @v setting		Setting to fetch
+ * @v raw		Raw setting value
+ * @v raw_len		Length of raw setting value
  * @v buf		Buffer to contain formatted value
  * @v len		Length of buffer
  * @ret len		Length of formatted value, or negative error
  */
-static int fetchf_int ( struct settings *settings, struct setting *setting,
-			char *buf, size_t len ) {
-	long value;
-	int rc;
+static int format_int_setting ( const void *raw, size_t raw_len, char *buf,
+				size_t len ) {
+	signed long value;
+	unsigned long dummy;
+	int check_len;
 
-	if ( ( rc = fetch_int_setting ( settings, setting, &value ) ) < 0 )
-		return rc;
+	/* Extract numeric value */
+	check_len = numeric_setting_value ( raw, raw_len, &value, &dummy );
+	if ( check_len < 0 )
+		return check_len;
+	assert ( check_len == ( int ) raw_len );
+
+	/* Format value */
 	return snprintf ( buf, len, "%ld", value );
 }
 
 /**
- * Fetch and format value of unsigned integer setting
+ * Format unsigned integer setting value
  *
- * @v settings		Settings block, or NULL to search all blocks
- * @v setting		Setting to fetch
+ * @v raw		Raw setting value
+ * @v raw_len		Length of raw setting value
  * @v buf		Buffer to contain formatted value
  * @v len		Length of buffer
  * @ret len		Length of formatted value, or negative error
  */
-static int fetchf_uint ( struct settings *settings, struct setting *setting,
-			 char *buf, size_t len ) {
+static int format_uint_setting ( const void *raw, size_t raw_len, char *buf,
+				 size_t len ) {
+	signed long dummy;
 	unsigned long value;
-	int rc;
+	int check_len;
 
-	if ( ( rc = fetch_uint_setting ( settings, setting, &value ) ) < 0 )
-		return rc;
+	/* Extract numeric value */
+	check_len = numeric_setting_value ( raw, raw_len, &dummy, &value );
+	if ( check_len < 0 )
+		return check_len;
+	assert ( check_len == ( int ) raw_len );
+
+	/* Format value */
 	return snprintf ( buf, len, "%#lx", value );
 }
 
 /** A signed 8-bit integer setting type */
 struct setting_type setting_type_int8 __setting_type = {
 	.name = "int8",
-	.storef = storef_int8,
-	.fetchf = fetchf_int,
+	.parse = parse_int8_setting,
+	.format = format_int_setting,
 };
 
 /** A signed 16-bit integer setting type */
 struct setting_type setting_type_int16 __setting_type = {
 	.name = "int16",
-	.storef = storef_int16,
-	.fetchf = fetchf_int,
+	.parse = parse_int16_setting,
+	.format = format_int_setting,
 };
 
 /** A signed 32-bit integer setting type */
 struct setting_type setting_type_int32 __setting_type = {
 	.name = "int32",
-	.storef = storef_int32,
-	.fetchf = fetchf_int,
+	.parse = parse_int32_setting,
+	.format = format_int_setting,
 };
 
 /** An unsigned 8-bit integer setting type */
 struct setting_type setting_type_uint8 __setting_type = {
 	.name = "uint8",
-	.storef = storef_int8,
-	.fetchf = fetchf_uint,
+	.parse = parse_int8_setting,
+	.format = format_uint_setting,
 };
 
 /** An unsigned 16-bit integer setting type */
 struct setting_type setting_type_uint16 __setting_type = {
 	.name = "uint16",
-	.storef = storef_int16,
-	.fetchf = fetchf_uint,
+	.parse = parse_int16_setting,
+	.format = format_uint_setting,
 };
 
 /** An unsigned 32-bit integer setting type */
 struct setting_type setting_type_uint32 __setting_type = {
 	.name = "uint32",
-	.storef = storef_int32,
-	.fetchf = fetchf_uint,
+	.parse = parse_int32_setting,
+	.format = format_uint_setting,
 };
 
 /**
- * Parse and store value of hex string setting
+ * Parse hex string setting value
  *
- * @v settings		Settings block
- * @v setting		Setting to store
- * @v value		Formatted setting data
- * @ret rc		Return status code
+ * @v value		Formatted setting value
+ * @v buf		Buffer to contain raw value
+ * @v len		Length of buffer
+ * @ret len		Length of raw value, or negative error
  */
-static int storef_hex ( struct settings *settings, struct setting *setting,
-			const char *value ) {
+static int parse_hex_setting ( const char *value, void *buf, size_t len ) {
 	char *ptr = ( char * ) value;
-	uint8_t bytes[ strlen ( value ) ]; /* cannot exceed strlen(value) */
-	unsigned int len = 0;
+	uint8_t *bytes = buf;
+	unsigned int count = 0;
+	uint8_t byte;
 
 	while ( 1 ) {
-		bytes[len++] = strtoul ( ptr, &ptr, 16 );
+		byte = strtoul ( ptr, &ptr, 16 );
+		if ( count++ < len )
+			*bytes++ = byte;
 		switch ( *ptr ) {
 		case '\0' :
-			return store_setting ( settings, setting, bytes, len );
+			return count;
 		case ':' :
 		case '-' :
 			ptr++;
